<template>
  <div>
    <a
      class="btn btn-primary float-right mx-2"
      href="features.csv"
      download="features.csv"
      >Download CSV</a
    >
    <form>
      <div class="form-row">
        <div class="form-group col-md-2">
          <label>Introduced after (including)</label>
          <multiselect
            v-model="minVersion"
            :options="allVersions"
            :customLabel="renderVersion"
            :allowEmpty="false"
          />
        </div>
        <div class="form-group col-md-2">
          <label>Introduced before (including)</label>
          <multiselect
            v-model="maxVersion"
            :options="allVersions"
            :customLabel="renderVersion"
            :allowEmpty="false"
          />
        </div>
        <div class="form-group col-md-2">
          <label>Minimum tier</label>
          <multiselect
            v-model="selectedMinTier"
            :options="allTiers"
            placeholder="Select a minimum tier"
          />
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-md-3">
          <label>Stage</label>
          <multiselect
            v-model="selectedStages"
            :options="allStages"
            :multiple="true"
            placeholder="Select one or multiple stages"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Category</label>
          <multiselect
            v-model="selectedCategories"
            :options="allCategories"
            :multiple="true"
            placeholder="Select one or multiple categories"
          />
        </div>
      </div>
      <div class="form-row">
        <div
          class="form-group col-md-3"
          data-toggle="tooltip"
          data-placement="top"
          title="Search supports regular expressions."
        >
          <label>Fulltext search</label>
          <input
            class="form-control"
            placeholder="Search feature name and description"
            v-model="textSearch"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Order By</label><br />
          <div class="btn-group" role="group" aria-label="Basic example">
            <select class="custom-select" v-model="orderKey">
              <option value="version">Version</option>
            </select>
            <button
              type="button"
              @click="order = order * -1"
              class="btn btn-outline-dark"
            >
              {{ order < 0 ? "Asc" : "Desc" }}
            </button>
          </div>
        </div>
      </div>
      Showing {{ filteredFeatures.length }} of {{ features.length }} features
    </form>
    <table class="table table-hover table-striped features-table">
      <thead>
        <tr>
          <th>Version</th>
          <th>Tier</th>
          <th>Stage</th>
          <th>Categories</th>
          <th>Description</th>
          <th>Links</th>
        </tr>
      </thead>
      <tbody>
        <tr
          :key="feature.version + feature.name"
          v-for="feature in filteredFeatures"
        >
          <td>{{ renderVersion(feature.version.replace(/_0?/, ".")) }}</td>
          <td>{{ (feature.available_in || []).join(", ") }}</td>
          <td>{{ feature.stage }}</td>
          <td>{{ (feature.categories || []).join(", ") }}</td>
          <td>
            <strong>{{ feature.name }}</strong
            ><br /><span v-html="feature.description"></span>
          </td>
          <td>
            <a
              v-if="feature.documentation_link"
              :href="feature.documentation_link"
              >Documentation</a
            >
            <a v-if="feature.issue_url" :href="feature.issue_url">Issue</a>
            <a v-if="feature.video" :href="feature.video">Video</a>
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr>
          <th>Version</th>
          <th>Tier</th>
          <th>Stage</th>
          <th>Categories</th>
          <th>Description</th>
          <th>Links</th>
        </tr>
      </tfoot>
    </table>
    Showing {{ filteredFeatures.length }} of {{ features.length }} features
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

const allTiersWithValue = [
  {
    name: "core",
    value: 10,
  },
  {
    name: "starter",
    value: 20,
  },
  {
    name: "premium",
    value: 30,
  },
  {
    name: "ultimate",
    value: 40,
  },
];

let searchDefaults = {
  order: 1,
  orderKey: "version",
  selectedCategories: [],
  selectedStages: [],
  textSearch: "",
  minVersion: null,
  maxVersion: null,
  selectedMinTier: "",
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    Multiselect,
  },
  data() {
    return {
      data: [],
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./features.json");

    this.data = await response.json();
    const params = new URLSearchParams(window.location.search);

    searchDefaults.minVersion = this.allVersions[0];
    searchDefaults.maxVersion = this.allVersions.slice(-1)[0];

    this.minVersion = searchDefaults.minVersion;
    this.maxVersion = searchDefaults.maxVersion;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }
      params.set("tab", "features");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version.replace(/^0/, "").replace(/_0?/, ".");
    },
  },
  computed: {
    allCategories() {
      return uniqAndSort(
        this.features.map((feature) => feature.categories).flat()
      );
    },
    allVersions() {
      return uniqAndSort(
        this.features.map((feature) => feature.version).flat()
      );
    },
    allStages() {
      return uniqAndSort(this.features.map((feature) => feature.stage).flat());
    },
    allTiers() {
      return Object.values(allTiersWithValue).map((x) => x.name);
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    features() {
      return this.data.map((feature) => {
        const { available_in, ...rest } = feature;

        const tiers = available_in.map((x) => {
          switch (x) {
            case "bronze":
              return "starter";
            case "silver":
              return "premium";
            case "gold":
              return "ultimate";
            case "free":
              return "core";
            default:
              return x;
          }
        });

        const minTier = allTiersWithValue.find((x) => tiers.includes(x.name))
          .value;

        return {
          available_in: tiers,
          minTier,
          ...rest,
        };
      });
    },
    filteredFeatures() {
      return this.features
        .filter((feature) => {
          let visible = true;
          if (visible && this.maxVersion) {
            visible = visible && feature.version <= this.maxVersion;
          }

          if (visible && this.minVersion) {
            visible = visible && feature.version >= this.minVersion;
          }

          if (visible && this.selectedStages.length) {
            visible =
              visible && this.selectedStages.includes(feature.stage || null);
          }

          if (visible && this.selectedMinTier) {
            visible =
              visible &&
              feature.minTier ===
                allTiersWithValue.find((x) => x.name === this.selectedMinTier)
                  .value;
          }

          if (visible && this.selectedCategories.length) {
            visible =
              visible &&
              (feature.categories || []).some((c) =>
                this.selectedCategories.includes(c)
              );
          }

          if (visible && this.textSearch) {
            const regex = new RegExp(this.searchLower, "gi");
            visible =
              visible &&
              (feature.name.toLocaleLowerCase().includes(this.searchLower) ||
                feature.description
                  .toLocaleLowerCase()
                  .includes(this.searchLower) ||
                feature.description.toLocaleLowerCase().match(regex));
          }

          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
